/***************************************************************************
                          openmosixmigmon.h  -  description
                             -------------------
    begin                : Son Jan  5 15:59:03 CET 2003
    copyright            : (C) 2003 by Matt
    email                : mosixview@t-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OPENMOSIXMIGMON_H
#define OPENMOSIXMIGMON_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qpopupmenu.h>
#include <qwhatsthis.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qlabel.h>
#include <qtimer.h>
#include <qdatetime.h>
#include <qtabdialog.h>
#include <qtoolbutton.h>

#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <list>
#include <map>
#include <iostream>
#include <fstream>
#include <dirent.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/resource.h>
#include <math.h>

#include "omproc.h"
#include "nodewidget.h"
#include "procwidget.h"
#include "omnode.h"

#define clustercommand "mosctl"
#define clusterdirectory "/proc/hpc/nodes/"
#define pi 3.1415926525
#define eheight 600
#define ewide 600
#define circlewide 400
#define xcenter 300
#define ycenter 300


using namespace std;





/**
  * This Class is the base class for your application. It sets up the main
  * window and providing a menubar, toolbar
  * and statusbar. For the main view, an instance of class OpenMosixmigmonView is
  * created which creates your view.
  */
class OpenMosixmigmonApp : public QMainWindow
{
  Q_OBJECT
  
  public:
    /** construtor */
    OpenMosixmigmonApp();
    /** destructor */
    ~OpenMosixmigmonApp();
    /** initializes all QActions of the application */

    // the nodelist
    list<omnode> nodelist;

    // get how many nodes we are
    int gethowmanynodes();

    // get my my nodeID
    string getmynodeID();

  	// howmany nodes we are
  	int clusternodes;

  	// check if the cluster configuration changed
  	bool checknodes();


    // the process-list
    list<oMProc> processlist;



  public slots:

    // updates the cluster nodes in the circle
    void updatenodes();

  	// set clusternodes to nodes
  	void setclusternodes(int nodes);

    // if the cluster changed
    void redraw();

    // howmany processes are running
    int gethowmanyprocs();

    // fills the processlist
    void fillprocesslist();

    // trigger to draw the processlist
    void drawprocesslist();

   /** shows help*/
    void slotHelp();

  protected:

    void paintEvent(QPaintEvent *);

    QLabel *QLabel_main;
    nodewidget *QLabel_tux;
    QLabel *QLabel_myid;
    nodewidget *QLabel_nodes[360];
    nodewidget *QLabel_nodeID[360];
    QToolButton *helpme;

    procwidget *singleproc[100000];

  private:


};
#endif 

